## mysql-community 8.0.26

=== debian/changelog ===
mysql-community (8.0.26-1debian10) buster; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-26.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Thu, 01 Jul 2021 08:20:38 +0000

=== debian/control ===
Source: mysql-community
Maintainer: MySQL Release Engineering <mysql-build@oss.oracle.com>
Section: database
Priority: optional
Standards-Version: 3.9.8
Homepage: http://www.mysql.com/
Build-Depends: debhelper (>= 9.0.0),
 libaio-dev[linux-any],
 libncurses5-dev (>= 5.0-6),
 libjson-perl, libldap2-dev,
 libsasl2-dev,
 perl,
 zlib1g-dev (>= 1:1.1.3-5),
 po-debconf,
 psmisc,
 bison,
 lsb-release,
 cmake,
 fakeroot,
 libnuma-dev,
 libmecab-dev,
   ,libssl-dev


Package: mysql-server
Architecture: any
Depends: mysql-community-server (= ${binary:Version}), ${misc:Depends}
Description: MySQL Server meta package depending on latest version
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This is a meta package that depends on the latest mysql server
 package available in the repository.

Package: mysql-community-server
Architecture: any
Pre-depends: debconf (>= 0.2.17), adduser
Depends: mysql-common (>= ${binary:Version}),
 mysql-client (= ${binary:Version}),
 mysql-community-server-core (= ${binary:Version}),
 perl,
 psmisc,
 ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-common (<< 5.7.14), mysql-community-client (<< 5.7)
Conflicts: mysql,
 mysql-server-5.0, mysql-server-core-5.0,
 mysql-server-5.1, mysql-server-core-5.1,
 mysql-server-5.5, mysql-server-core-5.5,
 mysql-server-5.6, mysql-server-core-5.6,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-commercial-server,
 mysql-cluster-community-server, mysql-cluster-commercial-server,
 mariadb-server-5.5, mariadb-server-core-5.5,
 mariadb-server-10.0, mariadb-server-core-10.0,
 mariadb-server-10.1, mariadb-server-core-10.1,
 mariadb-server-10.2, mariadb-server-core-10.2,
 mysql-client-5.0, mysql-client-core-5.0,
 mysql-client-5.1, mysql-client-core-5.1,
 mysql-client-5.5, mysql-client-core-5.5,
 mysql-client-5.6, mysql-client-core-5.6,
 mysql-client-5.7, mysql-client-core-5.7,
 mariadb-client-5.5, mariadb-client-core-5.5,
 mariadb-client-10.0, mariadb-client-core-10.0,
 mariadb-client-10.1, mariadb-client-core-10.1,
 mariadb-client-10.2, mariadb-client-core-10.2
Replaces: mysql,
 mysql-server-5.0, mysql-server-core-5.0,
 mysql-server-5.1, mysql-server-core-5.1,
 mysql-server-5.5, mysql-server-core-5.5,
 mysql-server-5.6, mysql-server-core-5.6,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-community-client (<< 5.7),
 mysql-commercial-server,
 mysql-cluster-community-server, mysql-cluster-commercial-server,
 mysql-common (<< 5.7.14)
Provides: virtual-mysql-server
Description: MySQL Server
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package includes the MySQL server binary as well as related
 utilities to run and administer a MySQL server.

Package: mysql-community-server-core
Architecture: any
Recommends: mecab-ipadic-utf8
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-community-server (<< 8.0.1),
 mysql-commercial-server (<< 8.0.1),
Conflicts: mysql,
 mysql-server-core-5.7,
 mysql-server-core-8.0,
 mysql-commercial-server-core,
 mariadb-server-core-10.1,
 mariadb-server-core-10.2,
 mariadb-server-core-10.3
Replaces: mysql-community-server (<< 8.0.1),
 mysql-commercial-server (<< 8.0.1),
 mysql-commercial-server-core,
 mysql-server-core-5.7,
 mysql-server-core-8.0
Provides: virtual-mysql-server-core
Description: MySQL Server Core Binaires
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package includes the core MySQL server binaries, but no
 configuration or service scripts.

Package: mysql-client
Architecture: any
Depends: mysql-community-client (= ${binary:Version}), ${misc:Depends}
Description: MySQL Client meta package depending on latest version
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This is a meta package that depends on the latest mysql client
 package available in the repository.

Package: mysql-community-client
Architecture: any
Depends: mysql-common (>= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends},
 mysql-community-client-core (= ${binary:Version}),
Breaks: mysql-common (<< 8.0.1),
 libmysqlclient-dev (<< 5.7.14),
Conflicts: mysql,
 mysql-client-5.7, mysql-client-core-5.7,
 mysql-client-8.0, mysql-client-core-8.0,
 mysql-commercial-client,
 mysql-cluster-community-client, mysql-cluster-commercial-client,
 mariadb-client-10.1, mariadb-client-core-10.1,
 mariadb-client-10.2, mariadb-client-core-10.2,
 mariadb-client-10.3, mariadb-client-core-10.3,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-server-8.0, mysql-server-core-8.0,
 mariadb-server-10.1, mariadb-server-core-10.1,
 mariadb-server-10.2, mariadb-server-core-10.2,
 mariadb-server-10.3, mariadb-server-core-10.3,
Replaces: mysql,
 mysql-client-5.7, mysql-client-core-5.7,
 mysql-client-8.0, mysql-client-core-8.0,
 mysql-commercial-client,
 mysql-cluster-community-client, mysql-cluster-commercial-client,
 mysql-common (<< 8.0.1),
 libmysqlclient-dev (<< 5.7.14)
Provides: virtual-mysql-client,
Description: MySQL Client
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the standard MySQL clients and
 administration tools.

Package: mysql-community-client-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-community-client-core (<< 8.0.22),
 mysql-commercial-client-core (<< 8.0.22),
 mysql-community-server (<< 8.0.21),
 mysql-community-server-core (<< 8.0.21),
 mysql-commercial-server (<< 8.0.21),
 mysql-commercial-server-core (<< 8.0.21),
Replaces: mysql-community-client-core (<< 8.0.22),
 mysql-commercial-client-core (<< 8.0.22),
 mysql-community-server (<< 8.0.21),
 mysql-community-server-core (<< 8.0.21),
 mysql-commercial-server (<< 8.0.21),
 mysql-commercial-server-core (<< 8.0.21),
Conflicts: mysql-commercial-client-plugins
Description: MySQL Client plugin
  The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
  and robust SQL (Structured Query Language) database server. MySQL Server
  is intended for mission-critical, heavy-load production systems as well
  as for embedding into mass-deployed software. MySQL is a trademark of
  Oracle. This package contains files used by both the client library and
  client package.


Package: mysql-community-client-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 mysql-community-client-plugins (= ${binary:Version}),
Breaks: libmysqlclient-dev (<< 5.7.14),
 mysql-community-client (<< 8.0.1),
 mysql-commercial-client (<< 8.0.1),
 mysql-community-server-core (<< 8.0.21),
 mysql-commercial-server-core (<< 8.0.21),
Conflicts: mysql,
 mysql-client-core-5.7,
 mysql-client-core-8.0,
 mysql-commercial-client-core,
 mariadb-client-core-10.1,
 mariadb-client-core-10.2,
 mariadb-client-core-10.3
Replaces: mysql,
 mysql-client-core-5.7,
 mysql-client-core-8.0,
 mysql-commercial-client,
 mysql-common (<< 5.7.17),
 mysql-community-client (<< 8.0.1),
 mysql-commercial-client (<< 8.0.1),
 mysql-commercial-client-core,
 libmysqlclient-dev (<< 5.7.14),
 mysql-community-server-core (<< 8.0.21),
 mysql-commercial-server-core (<< 8.0.21),
Provides: virtual-mysql-client-core
Description: MySQL Client Core Binaries
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the MySQL client binaries.


Package: libmysqlclient21
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: mysql-common (>= ${binary:Version}),
 mysql-community-client-plugins (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Description: MySQL shared client libraries
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the shared libraries for MySQL client
 applications.

Package: mysql-common
Architecture: any
Pre-depends: debconf (>= 0.2.17), ${misc:Pre-Depends}
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: mysql,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-client-5.7, mysql-client-core-5.7,
 mysql-server-8.0, mysql-server-core-8.0,
 mysql-client-8.0, mysql-client-core-8.0,
 mariadb-server-5.5, percona-xtradb-cluster-common-5.5,
 mysql-common (<< 5.7.14)
Replaces: mysql, libmysqlclient-dev,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-server-8.0, mysql-server-core-8.0,
 mariadb-server-5.5, percona-xtradb-cluster-common-5.5,
 mysql-common (<< 5.7.14)
Provides: mysql-common
Description: Common files shared between packages
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains common files needed by MySQL client
 library and MySQL database server.

Package: libmysqlclient-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient21 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Breaks: libmysqld-dev
Replaces: mysql-client-5.6, mysql-client-core-5.6,
 mysql-client-5.7, mysql-client-core-5.7,
 mysql-client-8.0, mysql-client-core-8.0,
 libmysqld-dev
Description: MySQL development headers
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the development header files necessary
 to develop MySQL client applications.

Package: mysql-testsuite
Architecture: any
Depends: mysql-community-test (= ${binary:Version}), ${misc:Depends}
Description: MySQL Testsuite meta package depending on latest version
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This is a meta package that depends on the latest mysql test
 package available in the repository.

Package: mysql-community-test
Architecture: any
Depends: mysql-community-server (= ${binary:Version}),
 mysql-community-client (= ${binary:Version}),
 libmysqlclient-dev, libjson-perl, mecab-ipadic-utf8,
 ${shlibs:Depends}, ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (c) 2015, 2021, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

%:
	dh $@

export DH_VERBOSE=1

ifeq (,$(MYSQL_BUILD_MAKE_JFLAG))
	JOBS=-j8
else
	JOBS=$(MYSQL_BUILD_MAKE_JFLAG)
endif


override_dh_auto_configure:
	@echo "RULES.$@"

	
	mkdir debug && cd debug && \
	cmake .. \
      -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
		-DBUILD_CONFIG=mysql_release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Debug \
		-DINSTALL_DOCDIR=share/mysql/docs \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DSYSCONFDIR=/etc/mysql \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DWITH_INNODB_MEMCACHED=1 \
		-DWITH_MECAB=system \
		-DWITH_NUMA=ON \
		-DCOMPILATION_COMMENT="MySQL Community - GPL - Debug" \
		-DCOMPILATION_COMMENT_SERVER="MySQL Community Server - GPL - Debug" \
		-DINSTALL_LAYOUT=DEB \
		-DREPRODUCIBLE_BUILD=OFF \
		-DUSE_LD_LLD=OFF \
		-DDEB_PRODUCT=community \
		


	mkdir release && cd release && \
	cmake .. \
      -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
		-DBUILD_CONFIG=mysql_release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DSYSCONFDIR=/etc/mysql \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DWITH_INNODB_MEMCACHED=1 \
		-DWITH_MECAB=system \
		-DWITH_NUMA=ON \
		-DCOMPILATION_COMMENT="MySQL Community - GPL" \
		-DCOMPILATION_COMMENT_SERVER="MySQL Community Server - GPL" \
		-DINSTALL_LAYOUT=DEB \
		-DREPRODUCIBLE_BUILD=OFF \
		-DUSE_LD_LLD=OFF \
		-DDEB_PRODUCT=community \
		

	touch $@

override_dh_auto_build:
	@echo "RULES.$@"
	
	cd debug && \
	$(MAKE) $(JOBS) VERBOSE=1

	cd release && \
	$(MAKE) $(JOBS) VERBOSE=1
	touch $@

override_dh_auto_test:
	@echo "RULES.$@"
	export CTEST_OUTPUT_ON_FAILURE=1
	cd release && \
	make test || true
	touch $@




override_dh_auto_install:

	@echo "RULES.$@"
	# complete install first
	cd release && \
	$(MAKE) install DESTDIR=../debian/tmp
	
	# The ini file isn't built for debug, so copy over from the standard build
	install -g root -o root -m 0755 debian/tmp/usr/lib/mysql/plugin/daemon_example.ini debian/tmp/usr/lib/mysql/plugin/debug

	# Add helper functions for maintainer scripts
	install -m 0644 debian/extra/mysql-helpers debian/tmp/usr/share/mysql-8.0/
	# add apparmor profile
	
	
	# add systemd scripts
	install -m 0755 debian/extra/mysql-systemd-start debian/tmp/usr/share/mysql-8.0/
	install -m 0755 debian/extra/mysqlrouter-systemd-start debian/tmp/usr/share/mysqlrouter/
	touch $@

override_dh_installinit:
	@echo "RULES.$@"
	
	
	dh_systemd_enable --name=mysql
	dh_installinit --name=mysql -- defaults 19 21
	dh_installinit --name=mysql@ -- disable
	dh_installinit --name=mysqlrouter -- defaults 19 21
	dh_systemd_start --restart-after-upgrade
	touch $@

override_dh_install:
	dh_install --fail-missing \
		-Xusr/bin/i_mysql_client_test \
		-Xmysql.server \
		-Xmysql.info \
		-XChangeLog \
		-Xusr/share/man/man1/mysqlman.1

# Since this dynamic library is included in both server and router, stripping
# it leads to file conflict errors when trying to install dbgsym-deb packages
# for both.
override_dh_strip:
	dh_strip -Xlibprotobuf-lite

## mysql-community 8.0.27

=== debian/changelog ===
mysql-community (8.0.27-1debian11) bullseye; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-27.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Tue, 28 Sep 2021 13:26:22 +0000

## mysql-community 8.0.28

=== debian/changelog ===
mysql-community (8.0.28-1debian11) bullseye; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-28.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Fri, 17 Dec 2021 16:38:30 +0000

=== debian/rules ===
--- 
+++ 
@@ -125,11 +125,9 @@
 	@echo "RULES.$@"
 	
 	
-	dh_systemd_enable --name=mysql
-	dh_installinit --name=mysql -- defaults 19 21
-	dh_installinit --name=mysql@ -- disable
+	dh_installsystemd --name=mysql
+	dh_installsystemd --name=mysql@ --no-enable --no-start
 	dh_installinit --name=mysqlrouter -- defaults 19 21
-	dh_systemd_start --restart-after-upgrade
 	touch $@
 
 override_dh_install:
@@ -145,3 +143,7 @@
 # for both.
 override_dh_strip:
 	dh_strip -Xlibprotobuf-lite
+
+# Debug plugins use libprotobuf-lite from the server package.
+override_dh_shlibdeps:
+	dh_shlibdeps -Lmysql-community-server-core -l/usr/lib/mysql/private

## mysql-community 8.0.30

=== debian/changelog ===
mysql-community (8.0.30-1debian11) bullseye; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-30.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Wed, 06 Jul 2022 22:09:11 +0000

## mysql-community 8.0.31

=== debian/changelog ===
mysql-community (8.0.31-1debian10) buster; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-31.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Tue, 13 Sep 2022 16:58:35 +0000

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
  po-debconf,
  psmisc,
  bison,
+ elfutils,
  lsb-release,
  cmake,
  fakeroot,

## mysql-community 8.0.32

=== debian/changelog ===
mysql-community (8.0.32-1debian10) buster; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-32.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Fri, 16 Dec 2022 16:07:04 +0000

=== debian/control ===
--- 
+++ 
@@ -90,6 +90,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Breaks: mysql-community-server (<< 8.0.1),
  mysql-commercial-server (<< 8.0.1),
+ mysql-common (<< 8.0.32)
 Conflicts: mysql,
  mysql-server-core-5.7,
  mysql-server-core-8.0,
@@ -100,6 +101,7 @@
 Replaces: mysql-community-server (<< 8.0.1),
  mysql-commercial-server (<< 8.0.1),
  mysql-commercial-server-core,
+ mysql-common (<< 8.0.32),
  mysql-server-core-5.7,
  mysql-server-core-8.0
 Provides: virtual-mysql-server-core
@@ -294,5 +296,3 @@
 Architecture: any
 Depends: mysql-community-server (= ${binary:Version}),
  mysql-community-client (= ${binary:Version}),
- libmysqlclient-dev, libjson-perl, mecab-ipadic-utf8,
- ${shlibs:Depends}, ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-# Copyright (c) 2015, 2021, Oracle and/or its affiliates.
+# Copyright (c) 2015, 2022, Oracle and/or its affiliates.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License, version 2.0,
@@ -40,7 +40,7 @@
 	
 	mkdir debug && cd debug && \
 	cmake .. \
-      -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
+    -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
 		-DBUILD_CONFIG=mysql_release \
 		-DCMAKE_INSTALL_PREFIX=/usr \
 		-DCMAKE_BUILD_TYPE=Debug \
@@ -62,7 +62,7 @@
 
 	mkdir release && cd release && \
 	cmake .. \
-      -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
+    -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
 		-DBUILD_CONFIG=mysql_release \
 		-DCMAKE_INSTALL_PREFIX=/usr \
 		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \

## mysql-community 8.0.37

=== storage/ndb/CMakeLists.txt ===
# Copyright (c) 2008, 2024, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

# Add both MySQL and NDB cmake repositories to search path
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
    ${CMAKE_SOURCE_DIR}/cmake
    ${CMAKE_SOURCE_DIR}/storage/ndb/cmake)
INCLUDE(ndb_add_target_property)
INCLUDE(ndb_add_test)
INCLUDE(ndb_add_executable)

MSVC_CPPCHECK_DISABLE()
DISABLE_MISSING_PROFILE_WARNING()

IF(NOT WITHOUT_SERVER)
  IF(NOT WITH_NDB AND NOT DEFINED WITH_NDBCLUSTER_STORAGE_ENGINE)
    IF(CMAKE_SIZEOF_VOID_P EQUAL 4)
      # Do not build ndbcluster plugin by default for 32-bit MySQL Server
      SET(WITH_NDBCLUSTER_STORAGE_ENGINE 0)
    ENDIF()
  ENDIF()
  #
  # Add the ndbcluster plugin
  #
  SET(NDBCLUSTER_SOURCES
    plugin/ha_ndbcluster.cc
    plugin/ha_ndbcluster_cond.cc
    plugin/ha_ndbcluster_push.cc
    plugin/ha_ndbcluster_connection.cc
    plugin/ha_ndbcluster_binlog.cc
    plugin/ha_ndb_index_stat.cc
    plugin/ha_ndb_ddl_fk.cc
    plugin/ha_ndbinfo.cc
    plugin/ha_ndbinfo_sql.cc
    plugin/ha_query_plan.cc
    plugin/ndb_local_connection.cc
    plugin/ndb_share.cc
    plugin/ndb_thd.cc
    plugin/ndb_thd_ndb.cc
    plugin/ndb_global_schema_lock.cc
    plugin/ndb_conflict_trans.cc
    plugin/ndb_anyvalue.cc
    plugin/ndb_ndbapi_util.cc
    plugin/ndb_binlog_extra_row_info.cc
    plugin/ndb_event_data.cc
    plugin/ndb_schema_object.cc
    plugin/ndb_schema_dist.cc
    plugin/ndb_component.cc
    plugin/ndb_repl_tab.cc
    plugin/ndb_conflict.cc
    plugin/ndb_tdc.cc
    plugin/ndb_log.cc
    plugin/ndb_binlog_thread.cc
    plugin/ndb_name_util.cc
    plugin/ndb_bitmap.cc
    plugin/ndb_table_map.cc
    plugin/ndb_dd.cc
    plugin/ndb_modifiers.cc
    plugin/ndb_dd_client.cc
    plugin/ndb_dd_schema.cc
    plugin/ndb_dd_table.cc
    plugin/ndb_dd_sdi.cc
    plugin/ndb_plugin_reference.cc
    plugin/ndb_server_hooks.cc
    plugin/ndb_binlog_client.cc
    plugin/ndb_metadata.cc
    plugin/ndb_dd_disk_data.cc
    plugin/ndb_dd_upgrade_table.cc
    plugin/ndb_binlog_hooks.cc
    plugin/ndb_util_table.cc
    plugin/ndb_schema_dist_table.cc
    plugin/ndb_fk_util.cpp
    plugin/ndb_schema_trans_guard.cc
    plugin/ndb_create_helper.cc
    plugin/ndb_apply_status_table.cc
    plugin/ndb_metadata_change_monitor.cc
    plugin/ndb_schema_result_table.cc
    plugin/ndb_metadata_sync.cc
    plugin/ndb_ddl_transaction_ctx.cc
    plugin/ndb_record_layout.cc
    plugin/ndb_sql_metadata_table.cc
    plugin/ndb_stored_grants.cc
    plugin/ndb_dd_fk.cc
    plugin/ndb_pfs_init.cc
    plugin/ndb_pfs_table.cc
    plugin/ndb_sync_pending_objects_table.cc
    plugin/ndb_sync_excluded_objects_table.cc
    plugin/ndb_dd_sync.cc
    plugin/ndb_upgrade_util.cc
    plugin/ndb_mysql_services.cc
    plugin/ndb_table_stats.cc
    plugin/ndb_index_stat_head_table.cc
    plugin/ndb_index_stat_sample_table.cc
    plugin/ndb_applier.cc
    plugin/ndb_replica.cc
    plugin/ndb_rpl_filter.cc
  )

  # Include directories used when building ha_ndbcluster
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/storage/ndb/include)

  # This will add WITH_NDBCLUSTER_STORAGE_ENGINE to the CACHE,
  # unless it is explicitly disabled on the command line.
  MYSQL_ADD_PLUGIN(ndbcluster ${NDBCLUSTER_SOURCES} STORAGE_ENGINE
    DEFAULT STATIC_ONLY
    LINK_LIBRARIES ndbclient_static extra::rapidjson)

  # Sanity check that MYSQL_ADD_PLUGIN didn't decide to skip build
  IF (NOT WITH_NDBCLUSTER_STORAGE_ENGINE)
    IF(WITH_NDB)
      MESSAGE(FATAL_ERROR
        "Ndbcluster plugin required when building MySQL Cluster")
    ELSE()
      RETURN()
    ENDIF()
  ELSE()
    MESSAGE(STATUS "Building ndbcluster plugin")
  ENDIF()

  NDB_ADD_TEST("ndb_bitmap-t" "plugin/ndb_bitmap.cc" LIBS ndbgeneral)
  NDB_ADD_TEST("ndb_blobs_buffer-t" "plugin/ndb_blobs_buffer.cc" LIBS ndbgeneral)
ELSEIF(NOT WITH_NDB)
  IF(WITH_NDBCLUSTER_STORAGE_ENGINE)
    MESSAGE(WARNING "Skips building ndbcluster plugin, WITHOUT_SERVER=ON "
      "overrides WITH_NDBCLUSTER_STORAGE_ENGINE=ON")
  ENDIF()
  RETURN()
ENDIF()

# Disable strict-aliasing for storage/ndb
IF(MY_COMPILER_IS_GNU_OR_CLANG)
  STRING_APPEND(CMAKE_C_FLAGS   " -fno-strict-aliasing")
  STRING_APPEND(CMAKE_CXX_FLAGS " -fno-strict-aliasing")
ENDIF()

# Disable specific types of warnings for current directory, and subdirectories,
# if the compiler supports the flag
FOREACH(warning
    )
  MY_CHECK_CXX_COMPILER_WARNING("${warning}" HAS_WARN_FLAG)
  IF(HAS_WARN_FLAG)
    STRING_APPEND(CMAKE_CXX_FLAGS " ${HAS_WARN_FLAG}")
    STRING_APPEND(CMAKE_C_FLAGS " ${HAS_WARN_FLAG}")
  ENDIF()
ENDFOREACH()

IF(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
  MESSAGE(WARNING "Only 64-bit build of NDB is supported")
ENDIF()

INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/ndb_configure.cmake)

INCLUDE_DIRECTORIES(
  # NDB includes
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/include/util
  ${CMAKE_CURRENT_SOURCE_DIR}/include/portlib
  ${CMAKE_CURRENT_SOURCE_DIR}/include/debugger
  ${CMAKE_CURRENT_SOURCE_DIR}/include/transporter
  ${CMAKE_CURRENT_SOURCE_DIR}/include/kernel
  ${CMAKE_CURRENT_SOURCE_DIR}/include/mgmapi
  ${CMAKE_CURRENT_SOURCE_DIR}/include/mgmcommon
  ${CMAKE_CURRENT_SOURCE_DIR}/include/ndbapi
  ${CMAKE_CURRENT_SOURCE_DIR}/include/logger
  ${CMAKE_CURRENT_BINARY_DIR}/include
)

SET(DEBUG_FLAGS
  -DACC_SAFE_QUEUE
  -DAPI_TRACE
  -DARRAY_GUARD
  -DERROR_INSERT
  -DNDB_DEBUG
  -DVM_TRACE
  )
SET(DEBUG_FLAGS_STRING "")
FOREACH(flag ${DEBUG_FLAGS})
  STRING_APPEND(DEBUG_FLAGS_STRING " ${flag}")
ENDFOREACH()

STRING_APPEND(CMAKE_C_FLAGS_DEBUG "${DEBUG_FLAGS_STRING}")
STRING_APPEND(CMAKE_CXX_FLAGS_DEBUG "${DEBUG_FLAGS_STRING}")

OPTION(WITH_ERROR_INSERT
  "Enable error injection in NDB" OFF)
IF(WITH_ERROR_INSERT)
  ADD_DEFINITIONS(-DERROR_INSERT)
ENDIF()

OPTION(WITH_NDB_DEBUG
  "Enable special ndb NDB features(including ERROR_INSERT)" OFF)
IF(WITH_NDB_DEBUG)
  ADD_DEFINITIONS(${DEBUG_FLAGS})
ENDIF()

# Set extra compiler switches from WITH_NDB_CCFLAGS
SET(WITH_NDB_CCFLAGS "" CACHE STRING "Extra compiler flags for NDB")
IF(WITH_NDB_CCFLAGS)
  MESSAGE(STATUS
    "Appending extra compiler flags for NDB: \"${WITH_NDB_CCFLAGS}\"")
  STRING_APPEND(CMAKE_C_FLAGS   " ${WITH_NDB_CCFLAGS}")
  STRING_APPEND(CMAKE_CXX_FLAGS " ${WITH_NDB_CCFLAGS}")
ENDIF()

# Set extra compiler switches from environment variable NDB_EXTRA_FLAGS
SET(ndb_flags_env $ENV{NDB_EXTRA_FLAGS})
IF(ndb_flags_env)
  MESSAGE(STATUS "Appending extra compiler flags for NDB from "
                 "environment: \"${ndb_flags_env}\"")
  STRING_APPEND(CMAKE_C_FLAGS   " ${ndb_flags_env}")
  STRING_APPEND(CMAKE_CXX_FLAGS " ${ndb_flags_env}")
ENDIF()

# Moved here from configure.cmake
CHECK_FUNCTION_EXISTS (getrlimit HAVE_GETRLIMIT)

IF(WITH_ASAN)
  MESSAGE(STATUS "Skip building ClusterJ by default for ASAN builds")
  SET(WITH_NDB_JAVA_DEFAULT OFF)
ELSE()
  # Check if the default for WITH_NDB_JAVA should be
  # magically overriden
  SET(magic_value $ENV{PRODUCT_ID})
  IF (magic_value STREQUAL "bootstrap-cmake-tar-gz" OR
      magic_value STREQUAL "source-dist-tar-gz")
    SET(WITH_NDB_JAVA_DEFAULT OFF)
    MESSAGE(STATUS "Default value for WITH_NDB_JAVA set to 0 since "
                   "bootstrapping was detected")
  ELSE()
  SET(WITH_NDB_JAVA_DEFAULT ${WITH_NDB})
  ENDIF()
ENDIF()
OPTION(WITH_NDB_JAVA
  "Include NDB Cluster Java components" ${WITH_NDB_JAVA_DEFAULT})

IF(WITH_NDB_JAVA)
  INCLUDE(ndb_find_java)
ELSE(WITH_NDB_JAVA)
  MESSAGE(STATUS "Excluding Cluster Java components")
ENDIF(WITH_NDB_JAVA)

ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)

IF(NOT WITH_NDB)
  RETURN()
ENDIF()

IF (OPENSSL_MAJOR_MINOR_FIX_VERSION VERSION_LESS "1.0.2")
  MESSAGE(WARNING
    "MySQL Cluster Transparent Data Encryption (TDE) not supported."
    "Needs OpenSSL 1.0.2 or newer.")
ENDIF()

SET(WITH_NDBAPI_EXAMPLES_DEFAULT OFF)
OPTION(WITH_NDB_TEST
  "Include the NDB Cluster ndbapi test programs" OFF)
IF(WITH_NDB_TEST)
  MESSAGE(STATUS "Building NDB test programs")
ELSE()
  # Turn on NDB tests automatically for gcov builds
  IF(ENABLE_GCOV AND NOT WIN32 AND NOT APPLE)
    MESSAGE(STATUS "Building NDB test programs for improved gcov coverage")
    SET(WITH_NDB_TEST ON)
    MESSAGE(STATUS "Building NdbApi examples for improved gcov coverage")
    SET(WITH_NDBAPI_EXAMPLES_DEFAULT ON)
  ENDIF()
  # Turn on NDB tests automatically for valgrind builds
  IF(WITH_VALGRIND)
    MESSAGE(STATUS "Building NDB test programs for improved valgrind coverage")
    SET(WITH_NDB_TEST ON)
    MESSAGE(STATUS "Building NdbApi examples for improved valgrind coverage")
    SET(WITH_NDBAPI_EXAMPLES_DEFAULT ON)
  ENDIF()
  # Turn on NDB tests automatically for "-devbld" debug builds
  # to increase test coverage
  IF(PACKAGE_SUFFIX STREQUAL "-devbld" AND
     CMAKE_BUILD_TYPE_UPPER STREQUAL "DEBUG")
    MESSAGE(STATUS "Building NDB test programs for \"-devbld\" debug build")
    SET(WITH_NDB_TEST ON)
    MESSAGE(STATUS "Building NdbApi examples for \"-devbld\" debug build")
    SET(WITH_NDBAPI_EXAMPLES_DEFAULT ON)
  ENDIF()
  # Turn on build of NDB tests automatically for "-werror" builds
  IF(PACKAGE_SUFFIX STREQUAL "-werror")
    MESSAGE(STATUS "Building NDB test programs for \"-werror\" build")
    SET(WITH_NDB_TEST ON)
    MESSAGE(STATUS "Building NdbApi examples for \"-werror\" build")
    SET(WITH_NDBAPI_EXAMPLES_DEFAULT ON)
  ENDIF()
ENDIF()

ADD_SUBDIRECTORY(tools)
ADD_SUBDIRECTORY(test)
IF(WITH_NDB_TEST)
  ADD_SUBDIRECTORY(src/cw/cpcd)
ENDIF()
IF(WITH_NDB_JAVA)
  ADD_SUBDIRECTORY(clusterj)
ENDIF()

SET(WITH_NDB_NODEJS_DEFAULT ON)

# Check if the default for WITH_NDB_NODEJS should be overriden
# by environment variable
IF(DEFINED ENV{WITH_NDB_NODEJS_DEFAULT})
  SET(WITH_NDB_NODEJS_DEFAULT $ENV{WITH_NDB_NODEJS_DEFAULT})
  MESSAGE(STATUS
    "Default value for WITH_NDB_NODEJS set to ${WITH_NDB_NODEJS_DEFAULT}")
ENDIF(DEFINED ENV{WITH_NDB_NODEJS_DEFAULT})

OPTION(WITH_NDB_NODEJS
  "Include NDB Cluster node.js components" ${WITH_NDB_NODEJS_DEFAULT})
IF(WITH_NDB_NODEJS)
  ADD_SUBDIRECTORY(nodejs)
ENDIF(WITH_NDB_NODEJS)

OPTION(WITH_NDBAPI_EXAMPLES
  "Build the NdbApi example programs" ${WITH_NDBAPI_EXAMPLES_DEFAULT})
IF(WITH_NDBAPI_EXAMPLES)
  MESSAGE(STATUS "Building the NdbApi example programs")
  ADD_SUBDIRECTORY(ndbapi-examples)
ENDIF()

## WiX support disabled for now
# ADD_SUBDIRECTORY(wix)

=== storage/ndb/src/common/util/CMakeLists.txt ===
# Copyright (c) 2008, 2024, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA


INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_BINARY_DIR}/storage/ndb/include
  ${CMAKE_SOURCE_DIR}/storage/ndb/include
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/util
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/portlib
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/logger
  )

ADD_DEFINITIONS(-DNO_DUMMY_DECL)
ADD_CONVENIENCE_LIBRARY(ndbgeneral
  BaseString.cpp
  Bitmask.cpp
  CharsetMap.cpp
  CharsetMapImpl.cpp
  Checksum.cpp
  ConfigValues.cpp
  File.cpp
  InputStream.cpp
  LogBuffer.cpp
  NdbOut.cpp
  NdbPack.cpp
  NdbSocket.cpp
  NdbSqlUtil.cpp
  ndb_az31.cpp
  ndb_ndbxfrm1.cpp
  ndb_openssl3_compat.cpp
  ndb_openssl_evp.cpp
  ndb_zlib.cpp
  ndbxfrm_file.cpp
  OutputStream.cpp
  OwnProcessInfo.cpp
  Parser.cpp
  ProcessInfo.cpp
  Properties.cpp
  SimpleProperties.cpp
  SocketAuthenticator.cpp
  SocketClient.cpp
  SocketServer.cpp
  Vector.cpp
  basename.cpp
  decimal_utils.cpp
  md5_hash.cpp
  ndb_init.cpp
  ndb_opts.cpp
  ndb_rand.cpp
  parse_mask.cpp
  random.cpp
  require.cpp
  socket_io.cpp
  version.cpp
  LINK_LIBRARIES ndbtrace ndbportlib ext::zlib mysys
)

# Exclude ndbgeneral_objlib from PGO on Windows to avoid linker error LNK1248
EXCLUDE_FROM_MSVC_PGO(ndbgeneral_objlib)

# Cyclic dependencies for ndbgeneral.
SET_TARGET_PROPERTIES(ndbgeneral PROPERTIES LINK_INTERFACE_MULTIPLICITY 3)

FOREACH(tests BaseString Bitmask SparseBitmask Parser HashMap2 LinkedStack
        ndb_zlib cstrbuf span)
  NDB_ADD_TEST("${tests}-t" "${tests}.cpp" LIBS ndbgeneral)
ENDFOREACH(tests)

# This looks like a gcc bug, there *are* ATTRIBUTE_FORMAT annotations for
# cstrbuf::appendf()
IF(WITH_UNIT_TESTS)
  IF(MY_COMPILER_IS_GNU AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 13)
    TARGET_COMPILE_OPTIONS(cstrbuf-t PRIVATE
      "-Wno-error=suggest-attribute=format")
  ENDIF()
ENDIF()

NDB_ADD_TEST(ndb_version-t version.cpp LIBS ndbgeneral)

FOREACH(tests
    NdbPack
    mysql_utils_test
    ndb_openssl_evp
    ndbxfrm_file
    NdbSqlUtil
    md5_hash
    LogBuffer
    testSimpleProperties
    testProp
    testSecureSocket
    testConfigValues
    )
  NDB_ADD_TEST("${tests}-t" "${tests}.cpp" LIBS ndbmgmapi ndbgeneral ndbportlib)
ENDFOREACH(tests)
